/**************************************/
/* clip_codbar */
/* clip image to keep only codebar */
/* Tarik Fdil <tfdil@sagma.ma> */
/* december 2004 */
/* Licence GPL cf. http://www.gnu.org */
/**************************************/

#include "tiffio.h"
#define max(a,b) ((a)>(b))?(a):(b)
#define min(a,b) ((a)<(b))?(a):(b)
#define isblack(x,y) (buf[(y)*(*w)+(x)] & 0x00FFFFFF)?0:1

uint32 *clip_codbar(uint32 *w, uint32 *h,uint32 *buf)
{
int i,x,y,n,x1,x2,y1,y2; /* (x1,y1) left lower corner, (x2,y2) right upper corner */
uint32* raster;
long total_pixel,black_pixel,npixels;
int width,height;
uint32 m,c,b;
uint32 red=0x000000ff;

x1=y1=x2=y2=0;
m=200;
for(x=m; x<*w-m; x++) for (y=m; y<*h-m; y++) {
	if(isblack(x,y)) {
		if(!x1) x1=x;
		if(!y1) y1=y;
		if(x>x2)x2=x;
		if(y>y2)y2=y;
	} 
}
m=(y2-y1)/5;
y1 += m; 
y2 -= m; 
width=x2-x1+1;
height=y2-y1+1;
npixels=width*height;
if((raster = (uint32*) _TIFFmalloc(npixels * sizeof (uint32))) ==NULL) return raster; 

n=0;
for (y=y1; y<=y2; y++) for(x=x1; x<=x2; x++) {
	raster[n]=buf[x+y*(*w)];
	n++;
}

*w=width;
*h=height;
return raster;

}
