/**************************************/
/* thining by Marthon algorithm */
/* Tarik Fdil <tfdil@sagma.ma> */
/* april 2005 */
/* Licence GPL cf. http://www.gnu.org */
/**************************************/
#include <tiffio.h>
#include <stdlib.h>
#define isblack(a,b) ((a)<0||(b)<0||(a)==w||(b)==h)?0:(buf[(b)*w+(a)] & 0x00FFFFFF)?0:1
#define iswhite(a,b) ((a)<0||(b)<0||(a)==w||(b)==h)?1:(buf[(b)*w+(a)] & 0x00FFFFFF ^ 0x00FFFFFF)?0:1
#define min(a,b) ((a) < (b))? (a) : (b)
#define max(a,b) ((a) > (b))? (a) : (b)

void marthon(uint32 w, uint32 h,uint32 *buf)
{
int x,y,i,j,dx,dy,nv,more,white=0xffffffff;
int d[w*h];

do { 
	more=0;
	for(x=0; x<w; x++) 
		for(y=0; y<h; y++)
		{
			dx=dy=nv=0;
			for(i= -1; i<2; i++)
				for(j= -1; j<2; j++) {
					if(isblack(x+i,y+j) && (i || j )) {
						dx += i; 
						dy += j;	 
						nv++;
					}
				}
			dx = abs(dx);
			dy = abs(dy);
			d[w*y+x] = dx+dy;
			if(d[w*y+x]==3) {
				if (	nv==2 || nv==6 || 
					(nv==3 && max(dx,dy)==3) || 
					(nv==5 && max(dx,dy)==3)
				   )  d[w*y+x] = 5;
			}
		}	

	for(x=0; x<w; x++) 
		for(y=0; y<h; y++)
			if(d[w*y+x] > 3) {
				buf[w*y+x]=white;
				more=1;
			}
} while(more); 

	
} /* marthon */
